c ***************************************************************************
c     mrehook
c ***************************************************************************
c
      subroutine mrehook(x,v,n3tm)
c
c     This subroutine get a geometry from Polyrate side of the interface,
c     pass it to MCT module and finally return the energy.
c     (Titus V Albu February 2002)
c
      implicit double precision (a-h,o-z)
c
      include 'mcparm.inc'
      include 'mcperc.inc'
      include 'mccomm.inc'
      include 'mcrate.inc'
c
      dimension x(n3tm)
c      dimension xii(n3tm)
c
c     Fill the xii array with the values from x that are species dependent
c
c      do i=1,n3tm
c         xii(i) = 0.d0
c      enddo
c      do k=1,mrnatm(mjtype)
c         do j=1,mcmatm
c            if (j.eq.miatsv(k,mjtype)) then
c               xii(3*k-2)=x(3*j-2)
c               xii(3*k-1)=x(3*j-1)
c               xii(3*k)=x(3*j)
c            endif
c         enddo
c      enddo
c
c     Determine the type of calculation (SCMM or MCMM)
c
c      mrjord = mriord(mjtype)
      mrjord = mciord
c
c     Get energy from the MCT module
c
c      call mehook(xii,v,e1,e2,e12,n3tm,mrjord,icomplex)
           if (ipermsym.eq.0) then                                         1106OT06
      call mehook(x,v,e1,e2,e12,n3tm,mrjord,icomplex)                          OT10
           else                                                            1106OT06
              call mehooks(x,v,e1,e2,e12,n3tm,mcjord,alphaV1,              1106OT06
     *        alphaV2,isigmav1,isigmav2,icomplex)                          1106OT06
           endif                                                           1106OT06
c
      return
      end
c ***************************************************************************
c     mrghook
c ***************************************************************************
c
      subroutine mrghook(x,v,dx,n3tm)
c
c     This subroutine get a geometry from Polyrate side of the interface,
c     pass it to MCT module and finally return the energy and gradient.
c     (Titus V Albu February 2002)
c
      implicit double precision (a-h,o-z)
c
      include 'mcparm.inc'
      include 'mcperc.inc'
      include 'mccomm.inc'
      include 'mcrate.inc'
c
      dimension x(n3tm)
      dimension dx(n3tm)
c      dimension xii(n3tm)
c      dimension dxii(n3tm)
c
      mcncar = 3*mcnatm
c
c     Fill the xii array with the values from x that are species dependent
c
c      do i=1,n3tm
c         xii(i) = 0.d0
c      enddo
c      do k=1,mrnatm(mjtype)
c         do j=1,mcmatm
c            if (j.eq.miatsv(k,mjtype)) then
c               xii(3*k-2)=x(3*j-2)
c               xii(3*k-1)=x(3*j-1)
c               xii(3*k)=x(3*j)
c            endif
c         enddo
c      enddo
c
c     Determine the type of calculation (SCMM or MCMM)
c
c      mrjord = mriord(mjtype)
      mrjord = mciord
c
c     Get energy and gradient from the MCT module
c
c      call mghook(xii,v,e1,e2,e12,dxii,n3tm,mrjord)
       if (ipermsym.eq.0) then                                             1106OT06
      call mghook(x,v,e1,e2,e12,dx,n3tm,mrjord,icomplex)                       OT10
            else                                                           1106OT06
             call mghooks(x,v,e1,e2,e12,dx,n3tm,                           1106OT06
     *       mcncar,mcjord,                                                1106OT06
     *       alphaV1,alphaV2,isigmav1,isigmav2,icomplex)                       OT10
            endif                                                          1106OT06
c
c     Fill the dx array with the values from dxii that were calculated
c
c      do k=1,mrnatm(mjtype)
c         do j=1,mcmatm
c            if (j.eq.miatsv(k,mjtype)) then
c               dx(3*j-2)=dxii(3*k-2)
c               dx(3*j-1)=dxii(3*k-1)
c               dx(3*j)=dxii(3*k)
c            endif
c         enddo
c      enddo
c
      return
      end
c ***************************************************************************
c     mrhhook
c ***************************************************************************
c
      subroutine mrhhook(x,v,dx,fmat,n3tm)
c
c     This subroutine get a geometry from Polyrate side of the interface,
c     pass it to MCT module and finally return the energy, gradient, and
c     Hessian.
c     (Titus V Albu February 2002)
c
      implicit double precision (a-h,o-z)
c
      include 'mcparm.inc'
      include 'mcperc.inc'
      include 'mccomm.inc'
      include 'mcrate.inc'
c
      dimension x(n3tm)
      dimension dx(n3tm)
      dimension fmat(n3tm,n3tm)
c      dimension xii(n3tm)
c      dimension dxii(n3tm)
c      dimension fmatii(n3tm,n3tm)
c
      mcncar = 3*mcnatm
c
c     Fill the xii array with the values from x that are species dependent
c
c      do i=1,n3tm
c         xii(i) = 0.d0
c      enddo
c      do k=1,mrnatm(mjtype)
c         do j=1,mcmatm
c            if (j.eq.miatsv(k,mjtype)) then
c               xii(3*k-2)=x(3*j-2)
c               xii(3*k-1)=x(3*j-1)
c               xii(3*k)=x(3*j)
c            endif
c         enddo
c      enddo
c
c     Determine the type of calculation (SCMM or MCMM)
c
c      mrjord = mriord(mjtype)
      mrjord = mciord
c
c     Get energy, gradient, and Hessian from the MCT module
c
c      call mhhook(xii,v,e1,e2,e12,dxii,fmatii,n3tm,mrjord)
           if (ipermsym.eq.0) then                                         1106OT06
      call mhhook(x,v,e1,e2,e12,dx,fmat,n3tm,mrjord,icomplex)                  OT10
           else                                                            1106OT06
            call mhhooks(x,v,e1,e2,e12,dx,f,mcmcar,mcncar,                 1106OT06
     *      mciord,                                                        1106OT06
     *      alphaV1,alphaV2,isigmav1,isigmav2,icomplex)                        OT10
           endif                                                           1106OT06
c
c     Fill the dx array with the values from dxii that were calculated
c
c      do k=1,mrnatm(mjtype)
c         do j=1,mcmatm
c            if (j.eq.miatsv(k,mjtype)) then
c               dx(3*j-2)=dxii(3*k-2)
c               dx(3*j-1)=dxii(3*k-1)
c               dx(3*j)=dxii(3*k)
c            endif
c         enddo
c      enddo
c
c     Fill the fmat array with the values from fmatii that were calculated
c
c      do k=1,mrnatm(mjtype)
c         do j=1,mcmatm
c            do ki=1,mrnatm(mjtype)
c               do ji=1,mcmatm
c                  if (j.eq.miatsv(k,mjtype).and.
c     *                ji.eq.miatsv(kii,mjtype)) then
c                     fmat(3*j,3*ji)=fmatii(3*k,3*ki)
c                     fmat(3*j,3*ji-1)=fmatii(3*k,3*ki-1)
c                     fmat(3*j,3*ji-2)=fmatii(3*k,3*ki-2)
c                     fmat(3*j-1,3*ji)=fmatii(3*k-1,3*ki)
c                     fmat(3*j-1,3*ji-1)=fmatii(3*k-1,3*ki-1)
c                     fmat(3*j-1,3*ji-2)=fmatii(3*k-1,3*ki-2)
c                     fmat(3*j-2,3*ji)=fmatii(3*k-2,3*ki)
c                     fmat(3*j-2,3*ji-1)=fmatii(3*k-2,3*ki-1)
c                     fmat(3*j-2,3*ji-2)=fmatii(3*k-2,3*ki-2)
c                  endif
c               enddo
c            enddo
c         enddo
c      enddo
c
      return
      end
c ***************************************************************************
c     mrprep
c ***************************************************************************
c
      subroutine mrprep(xr,initg,iatsv,label,nratom,natom,natoms)
c
c     This subroutine gets some information from Polyrate side of the
c     interface, and does some preparations for the calculation.
c     (Titus V Albu February 2002)
c
      implicit double precision (a-h,o-z)
c
      include 'mcparm.inc'
      include 'mcperc.inc'
      include 'mccomm.inc'
      include 'mcrate.inc'
c
      dimension initg(8)
      dimension nratom(8)
      dimension label(natoms)
      dimension iatsv(natoms,8)
      dimension xr(3*natoms,8)
c
      character*20 finame
      character*7  fistat
      character*20  fstat
      logical lexit
c
c     Open the general MC-TINKER file
c
      lexit  = .false.
      fistat = 'old'
      finame = 'esp.fu85'
      call mcfope (fu5, fistat, finame, lexit)
      if (lexit) then
         write (fu6,1000)
         stop 'mrprep 1'
      endif
 1000 format (1x,'Error opening the MCMM input file')
c
c     Read the options from the general MC-TINKER file
c
      call mcrfgi
c
c     Close the general MC-TINKER file
c
      fstat = 'keep'
      call mcfclo (fu5, fstat)
c
c     Tabulate the options read from the general MC-TINKER file
c
      call mcptab
c
c     Do some checks
c
      if (natoms.ne.mcmatm) then
         write (fu6,2000) natoms, mcmatm
         stop 'mrprep 2'
      endif
 2000 format (1x,'Error: the maximum number of atoms on the ',
     *           'Polyrate side of the interface',i5,
     *       /1x,'should be equal to the maximum number of atoms ',
     *           'on the MC-TINKER side',i5,'.')
c
      if (natom.ne.mcnatm) then
         write (fu6,3000) natom, mcnatm
         stop 'mrprep 3'
      endif
 3000 format (1x,'Error: the number of atoms on the Polyrate ',
     *           'side of the interface',i5,
     *       /1x,'should be equal to the number of atoms ',
     *           'on the MC-TINKER side',i5,'.')
c
      do i=1,mcnatm
         if (labmc(i).ne.label(i)) then
            write (fu6,4000) label(i), labmc(i)
            stop 'mrprep 4'
         endif
      enddo
 4000 format (1x,'Error: the atomic label on the Polyrate ',
     *           'side of the interface',i5,
     *       /1x,'should be same as the atomc label ',
     *           'on the MC-TINKER side',i5,'.')
c
c     Set up the rest of the (MC-TINKER) calculation.
c
      call mcscal
c
c     Fill the array mrnatm with the number of atoms for all species
c     and save the iatsv array in miatsv. In addition, define the 
c     values for the saddle point (jtype = 5).
c
      do jtype=1,8
         if (jtype.le.4.or.jtype.ge.7) then
            mrnatm(jtype)=nratom(jtype)
         elseif (jtype.eq.5.or.jtype.eq.6) then
            mrnatm(jtype)=natom
         endif
         do i=1,natoms
            miatsv(i,jtype)=iatsv(i,jtype)
         enddo
         if (jtype.eq.5.or.jtype.eq.6) then
            do j=1,natom
               miatsv(j,jtype)=j
            enddo
         endif
      enddo
c
c     Read the aditional options for the MC-TINKERATE calculations
c     from the esp.fu70 file.
c
      call mrrfao
c
c     Read the geometries from the esp.fu71 to esp.fu78 files
c
      do jtype=1,8
         if (initg(jtype).eq.1.and.jtype.ne.6) then
            call mrrfge(jtype,xr)
         endif
      enddo
c
c     Duplicate the molecular mechanics information. This is done because
c     the arrays of MC-TINKER will be overwrite with the information for
c     reactant1, reactant2. etc. (in mrprepj).
c
c      do j=1,mcmatm
c         do iconf=1,2
c            mitags(j,iconf)=itags(j,iconf)
c            mitype(j,iconf)=itype(j,iconf)
c            maname(j,iconf)=atname(j,iconf)
c            mincon(j,iconf)=incon(j,iconf)
c            do l=1,mcmatm
c               mico12(l,j,iconf)=icon12(l,j,iconf)
c            enddo
c         enddo
c      enddo
c
      return
      end
c ***************************************************************************
c     mrprepj
c ***************************************************************************
c
      subroutine mrprepj(jtype)
c
c     This subroutine gets some information from Polyrate side of the
c     interface, and does some preparations for the calculation that are
c     species dependent. Any initializations that are dependent
c     on wheter the reactants, products, saddle point, or generalized
c     transition state is computed should be done here.  JTYPE specifies
c     the species:
c
c           JTYPE               Species
c             1                 Reactant #1
c             2                 Reactant #2
c             3                 Product #1
c             4                 Product #2
c             5                 Saddle point
c             6                 Generalized transition states
c             7                 Reactant well
c             8                 Product well
c
c     (Titus V Albu February 2002)
c
      implicit double precision (a-h,o-z)
c
      include 'mcparm.inc'
      include 'mcperc.inc'
      include 'mccomm.inc'
      include 'mcrate.inc'
c
c      dimension intags(mcmatm,2)
c
c     Transfer of the MC-TINKER side of the interface the type of species
c     investigated. This is necessary as the type of MC-TINKER calculation
c     is to be carried out (MCMM or SCMM) may be species dependent.
c
      mjtype = jtype
c      mcnatm = mrnatm(jtype)
c
c     Zero the molecular mechanics information but not the information taken
c     from the key file
c
c      do j=1,mcmatm
c         do iconf=1,2
c            itags(j,iconf) = 0
c            itype(j,iconf) = 0
c            atname(j,iconf) = ' '
c            incon(j,iconf) = 0
c            do l=1,mcmatm
c               icon12(l,j,iconf) = 0
c            enddo
c         enddo
c      enddo
c
c     Recreate the molecular mechanics information which is species dependent
c
c      do j=1,mcmatm
c         do k=1,mrnatm(jtype)
c            if (j.eq.miatsv(k,jtype)) then
c               do iconf=1,2
c                  itags(k,iconf) = mitags(j,iconf)
c                  itype(k,iconf) = mitype(j,iconf)
c                  atname(k,iconf) = maname(j,iconf)
c                  incon(k,iconf) = mincon(j,iconf)
c                  do l=1,mcmatm
c                     icon12(l,k,iconf) = mico12(l,k,iconf)
c                  enddo
c               enddo
c            endif
c         enddo
c      enddo
c
c      At a later time I rewrite the above part as:
c
c      do k=1,mrnatm(jtype)
c         do j=1,mcmatm
c            if (j.eq.miatsv(k,jtype)) then
c               do iconf=1,2
c                  itags(k,iconf) = k
c                  intags(k,iconf) = mitags(j,iconf)
c                  itype(k,iconf) = mitype(j,iconf)
c                  atname(k,iconf) = maname(j,iconf)
c                  incon(k,iconf) = mincon(j,iconf)
c                  do l=1,mcmatm
c                     icon12(l,k,iconf) =
c     *                      mico12(l,mitags(j,iconf),iconf)
c                  enddo
c               enddo
c            endif
c         enddo
c      enddo
c
c      do iconf=1,2
c         do l=1,mcmatm
c            do k=1,mrnatm(jtype)
c               do j=1,mcmatm
c                  if (icon12(l,k,iconf).eq.mitags(j,iconf).and.
c     *                icon12(l,k,iconf).gt.0) then
c                     do ki=1,mrnatm(jtype)
c                        if (icon12(l,k,iconf).eq.intags(ki,iconf))
c     *                      then
c                           icon12(l,k,iconf)=ki
c                        endif
c                     enddo
c                  endif
c               enddo
c            enddo
c         enddo
c      enddo
c
      return
      end
